"{ Package: 'stx:goodies/petitparser/compiler' }"

PPCNode subclass:#PPCAbstractCharacterNode
	instanceVariableNames:'character'
	classVariableNames:''
	poolDictionaries:''
	category:'PetitCompiler-Nodes'
!

!PPCAbstractCharacterNode methodsFor:'accessing'!

acceptsEpsilon
	^ false
!

character
	^ character
!

character: char
	character := char
!

prefix
	^ #char
! !

!PPCAbstractCharacterNode methodsFor:'analysis'!

firstCharParser
	^ character asParser
! !

!PPCAbstractCharacterNode methodsFor:'compiling'!

body: compiler
	| id |

	character ppcPrintable ifTrue: [
		id := character printString
	] ifFalse: [
		id := compiler idFor: character prefixed: #char.
		compiler addConstant: (Character value: character asInteger) as: id .
	].

	compiler add: '(context peek == ', id, ')'.
	compiler indent.
	compiler add: 'ifFalse: [ self error: ''', character asInteger asString, ' expected'' at: context position ] '.
	compiler add: 'ifTrue: [ context next ].'.
	compiler dedent.
!

compileWith: compiler effect: effect id: id
	self start: compiler id: id.
	self body: compiler.
	^ self stop: compiler.
!

compileWith: compiler id: id
	self start: compiler.
	self body: compiler.
 	^ compiler stopMethod.
! !

